BICO 1.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Pages
Public Member Functions | List of all members
CluE::ProxyEvaluation< T > Class Template Referenceabstract

Abstract class for proxy-based evaluation algorithms. More...

`#include <proxyevaluation.h>`

Inheritance diagram for CluE::ProxyEvaluation< T >:
Collaboration diagram for CluE::ProxyEvaluation< T >:

## Public Member Functions
virtual | ~ProxyEvaluation ()
virtual double | proxycost (std::vector< T * > const &input, std::vector< T > const &proxies) const =0
| Calculates the cost related to the proxies based on the input. More...
virtual double | proxycost (std::vector< T * > const &input, ProxyProvider< T > const &proxies, unsigned int solutionIndex) const =0
virtual double | proxycost (std::vector< T * > const &input, std::vector< T > const &proxies, unsigned int proxyIndex) const =0
| Calculates the cost related to a single proxy chosen from the whole list, based on the input. More...
virtual double | proxycost (std::vector< T * > const &input, ProxyProvider< T > const &proxies, unsigned int solutionIndex, unsigned int proxyIndex) const =0
virtual double | proxycost (std::vector< T * > const &input, std::vector< T * > const &proxies) const =0
| Calculates the cost related to the discrete proxies based on the input. More...
virtual double | proxycost (std::vector< T * > const &input, DiscreteProxyProvider< T > const &proxies, unsigned int solutionIndex) const =0
virtual double | proxycost (std::vector< T * > const &input, std::vector< T * > const &proxies, unsigned int solutionIndex) const =0
| Calculates the cost related to a single discrete proxy chosen from the whole list, based on the input. More...
virtual double | proxycost (std::vector< T * > const &input, DiscreteProxyProvider< T > const &proxies, unsigned int solutionIndex, unsigned int proxyIndex) const =0
Public Member Functions inherited from CluE::Evaluation
virtual | ~Evaluation ()

## Detailed Description

### template<typename T>
class CluE::ProxyEvaluation< T >

Abstract class for proxy-based evaluation algorithms.

Evaluation algorithms requiring proxies for calculating the input's cost should derive from this class.

Definition at line 19 of file proxyevaluation.h.

## Constructor & Destructor Documentation

template<typename T >

virtual CluE::ProxyEvaluation< T >::~ProxyEvaluation | ( |  | ) |
| inline virtual

Definition at line 21 of file proxyevaluation.h.

## Member Function Documentation

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | std::vector< T > const & | proxies
| ) |  | const
| pure virtual

Calculates the cost related to the proxies based on the input.

Note
  There are separate overloaded versions of this method for use with discrete proxies.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | ProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | std::vector< T > const & | proxies,
|  | unsigned int | proxyIndex
| ) |  | const
| pure virtual

Calculates the cost related to a single proxy chosen from the whole list, based on the input.

Note
  There are separate overloaded versions of this method for use with discrete proxies.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | ProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex,
|  | unsigned int | proxyIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | std::vector< T * > const & | proxies
| ) |  | const
| pure virtual

Calculates the cost related to the discrete proxies based on the input.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | DiscreteProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | std::vector< T * > const & | proxies,
|  | unsigned int | solutionIndex
| ) |  | const
| pure virtual

Calculates the cost related to a single discrete proxy chosen from the whole list, based on the input.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::ProxyEvaluation< T >::proxycost | ( | std::vector< T * > const & | input,
|  | DiscreteProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex,
|  | unsigned int | proxyIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Implemented in CluE::KMeansEvaluator< T >.

The documentation for this class was generated from the following file:

- src/base/proxyevaluation.h